﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

//Spazio di nomi - textbure2d
using Microsoft.Xna.Framework.Graphics;
//spazio di nomi per il colore e rectangle
using Microsoft.Xna.Framework;



namespace XNATutorial
{
    class Animazione
    {
        // insieme d'immagine animazione
        Texture2D textureInsiemeImmagini;


        //per la visualizzazione del singolo frame
        float scala;


        //indica il tempo che è passato
        int TempoTrascorso;


        //tempo per la visualizzazione di ogni singolo frame
        int frameDurata;


        // numero dei frame (immagini)
        int frameTotali;


        //indice del frame corrente da visualizzare
        int frameCorrente;


        //colore del framew da visualizzare
        Color colore;


        //area per la visualizzazone dell'immagine
        Rectangle areaRect = new Rectangle();


        //oggetto per la definizione dell'area di destinazione delle immagini
        Rectangle AreaDestinazioneRect = new Rectangle();


        //larghezza framew
        public int FrameWidth;


        //altezzaFrame
        public int FrameHeight;


        //Stato Attivo Animazione
        public bool statoAttivo;


        //determina se attivare l'animazione oppure no
        public bool AttivaDisattivare;


        //posizione
        public Vector2 Posizione;


        public void Initialize(Texture2D texture, Vector2 posizione, int frameWidth, int frameHeight, int Frametotali, int FrameCorrente, Color Colore, float Scala, bool AttivaDisattiva)
        {
            //inizializzo i vari oggetti
            this.colore = Colore;
            this.FrameWidth = frameWidth;
            this.FrameHeight = frameHeight;
            this.frameTotali = Frametotali;
            this.frameDurata = FrameCorrente;
            this.scala = Scala;


            AttivaDisattivare = AttivaDisattiva;
            Posizione = posizione;
            textureInsiemeImmagini = texture;


            //imposto il tempo delle animazione
            TempoTrascorso = 0;
            frameCorrente = 0;


            //attivo l'animazione
            statoAttivo = true;

        }
        public void Update(GameTime gameTime)
        {
            //Verifico lo stato attivo se animare o no il game
            if (statoAttivo == false)
                return;


            //aggiorno il tempo trascorso
            TempoTrascorso += (int)gameTime.ElapsedGameTime.TotalMilliseconds;


            // In caso che ho tempo per il singolo frame è passato, passo all'immagine successiva
            if (TempoTrascorso > frameDurata)
            {
                //passo al frame successivo
                frameCorrente++;


                // se il frame corrente è la fine di tutto l'insieme lo riporto all'inzio
                if (frameCorrente == frameTotali)
                {
                    frameCorrente = 0;
                    //verifico se attivare o no il games
                    if (AttivaDisattivare == false)
                        statoAttivo = false;
                }


                //reimposto il tempo trascorso per il successivo frame
                TempoTrascorso = 0;
            }


            //ottengo l'area per la visualizzazione delle immagini
            areaRect = new Rectangle(frameCorrente * FrameWidth, 0, FrameWidth, FrameHeight);


            //imposto l'area per il posizionamento dell'immagine
            AreaDestinazioneRect = new Rectangle((int)Posizione.X - (int)(FrameWidth * scala) / 2,
            (int)Posizione.Y - (int)(FrameHeight * scala) / 2,
            (int)(FrameWidth * scala),
            (int)(FrameHeight * scala));

        }
        //Metodo per visualizzare a video l'immagine
        public void Draw(SpriteBatch spriteBatch)
        {
            //solo nel caso che lo stato è attivo
            if (statoAttivo)
            {
                spriteBatch.Draw(textureInsiemeImmagini, AreaDestinazioneRect, areaRect, colore);
            }

        }


    }
}
