﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

//spazio dei nomi
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace XNATutorial
{
    class Asteroide
    {

        //gestione per l'animazione dell'asteroide
        public Animazione AnimazioneAsteroide;

        //posizione dell'immagine
        public Vector2 Posizione;

        //lo stato attivo 
        public bool StatoAttivo;

        //Energia
        public int Energia;

        //Totale dei danni inflitti all'astronave
        public int DanniAstronave;

        //totale punteggio
        public int Punteggio;

        //larghezzza
        public int Width
        {
            get { return AnimazioneAsteroide.FrameWidth; }
        }

        //altezza
        public int Height
        {
            get { return AnimazioneAsteroide.FrameHeight; }
        }

        //La velocità di spostamento dell'immagine
        float Velocita;


        public void Initialize(Animazione animazione, Vector2 posizione)
        {
            //imposto la risorsa ossia l'immagine asteroide
            AnimazioneAsteroide = animazione;

            //imposto la posizione
            Posizione = posizione;

            //attivo lo stato
            StatoAttivo = true;


            //imposto l'energia
            Energia = 10;

            //imposto i danni all'astronave
            DanniAstronave = 10;

            //imposto la velocità di spostamento
            Velocita = 6f;


            //imposto il punteggio 
            Punteggio = 100;

        }



        public void Update(GameTime gameTime)
        {
            //imposto la posizione in riferimento alla velocità riducendo il valore
            Posizione.X -= Velocita;

            //imposto alla risorsa la posizione
            AnimazioneAsteroide.Posizione = Posizione;

            //aggiorno l'oggetto di tipo animazione
            AnimazioneAsteroide.Update(gameTime);

            //nel caso che non ho energia oppure non rientra più nello "spazio" visito lo disativo
            if (Posizione.X < -Width || Energia <= 0)
            {
                //Elimino la risorsa
                StatoAttivo = false;
            }
        }



        public void Draw(SpriteBatch spriteBatch)
        {
            //aggiorno la parte grafica
            AnimazioneAsteroide.Draw(spriteBatch);
        }




    }
}
