﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//per la calsse texture
using Microsoft.Xna.Framework.Graphics;
//per la classe vectory2
using Microsoft.Xna.Framework;
//per la gestione del ContentManager
using Microsoft.Xna.Framework.Content;

namespace XNATutorial
{
    class Sfondo
    {
        //gestione immagine sfondo
        Texture2D texture;


        //posizione dei pixel dells sfondo
        Vector2[] posizione;

        //velocità di spostamento delle immagini
        int Velocita;

        public void Initialize(ContentManager contenuto, String ImgPath, int Larghezza, int velocita)
        {
            //carica l'immagine di sfondo
            texture = contenuto.Load<Texture2D>(ImgPath);


            //imposto la velocità di spostamento
            this.Velocita = velocita;


            // per le dimensione dello sfondo
            posizione = new Vector2[Larghezza / texture.Width + 1];


            //imposto la posizione iniziale
            for (int i = 0; i < posizione.Length; i++)
            {
                posizione[i] = new Vector2(i * texture.Width, 0);
            }
        }
        public void Update()
        {
            //aggiorno la  posizione
            for (int i = 0; i < posizione.Length; i++)
            {
                //incremento la poszione in riferimento alla velocita
                posizione[i].X += Velocita;
                // verifico la velocità e sposto a sinistra
                if (Velocita <= 0)
                {
                    //verifico se è stata visualizzata alla fine dello schermo
                    if (posizione[i].X <= -texture.Width)
                    {
                        posizione[i].X = texture.Width * (posizione.Length - 1);
                    }
                }


                //sposto a destra lo sfondo
                else
                {
                    //imposto la posizione parte destra
                    if (posizione[i].X >= texture.Width * (posizione.Length - 1))
                    {
                        posizione[i].X = -texture.Width;
                    }
                }
            }

        }
        public void Draw(SpriteBatch spriteBatch)
        {
            for (int i = 0; i < posizione.Length; i++)
            {
                spriteBatch.Draw(texture, posizione[i], Color.White);
            }
        }
    }
}
