﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//per la gestione della classe Texture2d
using Microsoft.Xna.Framework.Graphics;
//per la classe Vector2
using Microsoft.Xna.Framework;

namespace XNATutorial
{
    class Sparo
    {

        //Gestione della risorsa per il fuoco
        public Texture2D TextureFuoco;

        //posizione della risorsa nello schermo
        public Vector2 Posizione;

        //Lo statoattivo
        public bool StatoAttivo;

        //valore relativo al danno recato agli asteroidi
        public int Danno;

        // riquadro di visualizzazione
        Viewport Viewport;

        //larghezza
        public int Width
        {
            get { return TextureFuoco.Width; }
        }

        //alterzza
        public int Height
        {
            get { return TextureFuoco.Height; }
        }

        //velocita di spostamento fuoco
        float VelocitaFuoco;


        public void Initialize(Viewport viewport, Texture2D texture, Vector2 posizione)
        {
            TextureFuoco = texture;
            Posizione = posizione;
            this.Viewport = viewport;

            StatoAttivo = true;

            Danno = 2;

            VelocitaFuoco = 20f;
        }
        public void Update()
        {
            //Permette lo spostamento del fuoco da sinistra a destra, incremendo la posizione tramite la velocita
            Posizione.X += VelocitaFuoco;

            //verifico se stiamo nell'area per la visualizzazione del fuoco
            if (Posizione.X + TextureFuoco.Width / 2 > Viewport.Width)
                StatoAttivo = false;

        }
        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(TextureFuoco, Posizione, null, Color.White, 0f,new Vector2(Width / 2, Height / 2), 1f, SpriteEffects.None, 0f);

        }



    }
}
